#ifndef MC6847_H_INCLUDED
#define MC6847_H_INCLUDED

#include "../typedef.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class MC6847core {
protected:
	BYTE COL_AN[5];			// J[R[h(At@j[bN)
	BYTE COL_SG[9];			// J[R[h(Z~OtBbN)
	BYTE COL_CG[10][8];		// J[R[h(J[OtBbN)
	BYTE COL_RG[2][2];		// J[R[h(mNOtBbN)
	// for 62,66,64,68 -----------------------------------------------------------------------
	BYTE COL_AN2[16];		// J[R[h(At@j[bN 60m)
	BYTE COL_CG2[2][16];	// J[R[h(J[OtBbN 60m)
	// ---------------------------------------------------------------------------------------
	
	static const BYTE NJM_TBL[][2];	// Fɂ݃J[R[he[u
	
	bool CrtDisp;			// CRT\			true:\	false:\
	bool BusReq;			// oXNGXg		true:ON		false:OFF
	bool N60Win;			// EBhETCY		true:N60	false:N60m
	int Mode4Col;			// [h4J[[h	0:m 1:/ 2:/ 3:sN/ 4:/sN
	
	WORD VAddr;				// AhXJE^
	WORD HAddr;				// AhXJE^
	int RowCntA;			// \CJE^(At@j[bN,Z~O)
	int RowCntG;			// \CJE^(OtBbN)
	
	// for 62,66,64,68 -----------------------------------------------------------------------
	bool CharMode;			// eLXg\[h	true:LN^				false:OtBbN
	bool GraphMode;			// OtBbN𑜓x	true:160*200(SR:320*200)	false:320*200(SR:640*200)
	int Css1;				// F̑gݍ킹
	int Css2;
	int Css3;
	// ---------------------------------------------------------------------------------------
	
	// for 64,68 -----------------------------------------------------------------------------
	bool SRmode;			// SR[htO 			true:SR-BASIC	false:BASIC
	bool SRBusReq;			// SRoXNGXgtO	true:L		false:
	bool SRBitmap;			// SRrbg}bvtO		true:L		false:
	bool SRBMPage;			// SRrbg}bvy[W		true:32KB	false:32KB
	bool SRLine204;			// SROtBbNC	true:204C	false:200C
	bool SRCharLine;		// SReLXgs			true:20s		false:25s
	bool SRCharWidth;		// SReLXg			true:40		false:80
	
	BYTE SRTextAddr;		// SReLXgVRAMAhX(0H-FH)
	WORD SRRollX;			// hbgXN[ XW
	WORD SRRollY;			// hbgXN[ YW
	WORD SRVramAddrY;		// OtBbNVRAM YW
	// ---------------------------------------------------------------------------------------
	
	// Agr[gf[^
	BYTE AT_AG;
	BYTE AT_AS;
	BYTE AT_IE;
	BYTE AT_GM;
	BYTE AT_CSS;
	BYTE AT_INV;
	
	// for 62,66,64,68 -----------------------------------------------------------------------
	void SetCss( BYTE );						// F̑gw
	virtual void SetCrtControler( BYTE );		// CRTRg[[hݒ
	// ---------------------------------------------------------------------------------------
	
	int GetW() const;							// obNobt@擾(Kl)
	int GetH() const;							// obNobt@擾(Kl)
	
	virtual BYTE *GetBufAddr() const = 0;		// obt@AhX擾
	virtual int GetBufPitch() const = 0;		// obt@sb`(1LineoCg)擾
	
	virtual void LatchGMODE() = 0;				// Agr[gf[^b`(OtBbN[ĥ)
	virtual void LatchAttr() = 0;				// Agr[gf[^b`
	virtual BYTE GetAttr() const = 0;			// Agr[gf[^擾
	virtual BYTE GetVram() const = 0;			// VRAMf[^擾
	virtual BYTE GetFont1( WORD ) const = 0;	// Font1f[^擾
	virtual BYTE GetFont2( WORD ) const = 0;	// Font2f[^擾
	virtual BYTE GetFont3( WORD ) const = 0;	// Font3f[^擾
	BYTE GetSemi4( BYTE ) const;				// Z~O4f[^擾
	virtual BYTE GetSemi6( BYTE ) const;		// Z~O6f[^擾
	
public:
	MC6847core();								// RXgN^
	virtual ~MC6847core();						// fXgN^
	
	virtual void UpdateBackBuf() = 0;			// obNobt@XV
	
	bool GetCrtDisp() const;					// CRT\Ԏ擾
	void SetCrtDisp( bool );					// CRT\Ԑݒ
	
	bool GetWinSize() const;					// EBhETCY擾
	
	int GetMode4Color() const;					// [h4J[[h擾
	void SetMode4Color( int );					// [h4J[[hݒ
};


class MC6847 : public virtual MC6847core {
protected:
	static const BYTE VDGfont[];				// VDG Font data
	
	void Draw1line1( int );						// 1C`(N60)
	
	#if INBPP == 8	// 8bit
	BYTE GetBcol() const;						// {[_[J[擾
	#else			// 32bit
	DWORD GetBcol() const;						// {[_[J[擾
	#endif
	
public:
	MC6847();									// RXgN^
	virtual ~MC6847();							// fXgN^
	
	void UpdateBackBuf();						// obNobt@XV
};


class PCZ80_07 : public virtual MC6847core {
protected:
	BYTE GetSemi6( BYTE ) const;				// Z~O6f[^擾
	
	void Draw1line1( int );						// 1C`(N60)
	void Draw1line2( int );						// 1C`(N60m)
	
	#if INBPP == 8	// 8bit
	BYTE GetBcol() const;						// {[_[J[擾
	#else			// 32bit
	DWORD GetBcol() const;						// {[_[J[擾
	#endif
	
public:
	PCZ80_07();									// RXgN^
	virtual ~PCZ80_07();						// fXgN^
	
	virtual void UpdateBackBuf();				// obNobt@XV
};


class PCZ80_12 : public virtual PCZ80_07 {
protected:
	BYTE GetSemi6( BYTE ) const;				// Z~O6f[^擾
	BYTE GetSemi8( BYTE ) const;				// Z~O8f[^擾
	
	void SetCrtControler( BYTE );				// CRTRg[[hݒ
	void SetCrtCtrlType( BYTE );				// CRTRg[^Cvݒ
	
	void Draw1line3( int );						// 1C`(SR)
	
public:
	PCZ80_12();									// RXgN^
	virtual ~PCZ80_12();						// fXgN^
	
	void UpdateBackBuf();						// obNobt@XV
	
	void SetPalette( int, BYTE );				// pbgݒ
};


#endif	// MC6847_H_INCLUDED
