#include "pc6001v.h"

#include "common.h"
#include "config.h"
#include "debug.h"
#include "graph.h"
#include "log.h"
#include "osd.h"
#include "status.h"
#include "vdg.h"

#include "p6el.h"


// ʏEBhETCY
#define	P6WINW		(vm->vdg->Width()*2/vm->vdg->XScale())
#define	P6WINH		(vm->vdg->Height()*2)

#define	HBBUS		((282-12)*2)	/* 4:3\ʍ */

// tXN[EBhETCY
#define	P6WIFW		640
#define	P6WIFH		480

#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// j^[hEBhETCY
#define	P6DEBUGW	(max(P6WINW/2,vm->el->monw->Width())+max(vm->el->regw->Width(),vm->el->memw->Width()))
#define	P6DEBUGH	(max(P6WINH/2+vm->el->monw->Height(),vm->el->regw->Height()+vm->el->memw->Height()))
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


// j^[h̓tXN[CXLCC4:3\֎~
// tXN[[h̓Xe[^Xo[\֎~
#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define	DISPMON		vm->el->IsMonitor()
#define	DISPFULL	(!DISPMON  && vm->el->cfg->GetFullScreen())
#define	DISPSCAN	(!DISPMON  && vm->el->cfg->GetScanLine())
#define	DISPNTSC	(!DISPMON  && vm->el->cfg->GetDispNTSC())
#else
#define	DISPFULL	vm->el->cfg->GetFullScreen()
#define	DISPSCAN	vm->el->cfg->GetScanLine()
#define	DISPNTSC	vm->el->cfg->GetDispNTSC()
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#define	DISPSTAT	(!DISPFULL && vm->el->cfg->GetDispStat())


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
//DSP6::DSP6( VM6 *pvm ) : vm(pvm), Wh(NULL), SBuf(NULL) {}
DSP6::DSP6( VM6 *pvm ) : vm(pvm), Wh(NULL) {}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
DSP6::~DSP6( void )
{
//	if( SBuf ) delete SBuf;
	if( Wh ) OSD_DestroyWindow( Wh );
}


////////////////////////////////////////////////////////////////
// 
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::Init( void )
{
	PRINTD( GRP_LOG, "[GRP][Init]\n" );
	
	// XN[T[tFX쐬
	if( !SetScreenSurface() ) return false;
	
	return true;
}


////////////////////////////////////////////////////////////////
// 
//
// :	model	@ 60,62,66
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::SetIcon( const int model )
{
	OSD_SetIcon( Wh, model );
}


////////////////////////////////////////////////////////////////
// XN[T[tFX쐬
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::SetScreenSurface( void )
{
	PRINTD( GRP_LOG, "[GRP][SetScreenSurface]\n" );
	
	int x = 0, y = 0;
	bool fsflag = false;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	if( DISPMON ){	// j^[h?
		x      = P6DEBUGW;
		y      = P6DEBUGH;
		fsflag = false;
		
		PRINTD( GRP_LOG, " -> Monitor Mode ( X:%d Y:%d )\n", x, y );
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	{
		if( DISPFULL ){	// tXN[?
			// Mac ̃tXN[ 640x480, 800x600, 1024x768 Ɍ炵Bby Windy
			// Ƃ肠ⓚp640x480ɌŒ肵Ă݂
			x      = P6WIFW;
			y      = P6WIFH;
			fsflag = true;
			
			PRINTD( GRP_LOG, " -> FullScreen ( X:%d Y:%d )\n", x, y );
		}else{
			x      = P6WINW;
			y      = (DISPNTSC ? HBBUS : P6WINH) + ( DISPSTAT ? vm->el->staw->Height() : 0 );
			fsflag = false;
			
			PRINTD( GRP_LOG, " -> Window ( X:%d Y:%d )\n", x, y );
		}
	}
	
	// XN[T[tFX쐬
	OSD_CreateWindow( &Wh, x, y, fsflag );
	if( !Wh ){
		PRINTD( GRP_LOG, " -> Failed\n" );
		return false;
	}else{
		PRINTD( GRP_LOG, " -> OK ( %d x %d )\n", OSD_GetWindowWidth( Wh ), OSD_GetWindowHeight( Wh ) );
	}
	
	if( DISPFULL ){	// tXN[̎
		// }EXJ[\
		OSD_ShowCursor( false );
	}else{			// tXN[łȂ
		// }EXJ[\\
		OSD_ShowCursor( true );
		// EBhELvVݒ
		OSD_SetWindowCaption( Wh, vm->el->cfg->GetCaption() );
	}
	
	return true;
}


////////////////////////////////////////////////////////////////
// XN[TCYύX
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::ResizeScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][ResizeScreen]\n" );
	
	int x, y;
	
	// EBhETCY`FbN
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	if( DISPMON ){	// j^[h?
		x = P6DEBUGW;
		y = P6DEBUGH;
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	{
		x = DISPFULL ? P6WIFW : P6WINW;
		y = DISPFULL ? P6WIFH : DISPNTSC ? HBBUS : P6WINH;
		
		// Xe[^Xo[\?
		if( !DISPFULL && DISPSTAT ) y += vm->el->staw->Height();
	}
	
	// EBhETCYsK؂Ȃ蒼
	if( !Wh || (x != OSD_GetWindowWidth( Wh )) || (y != OSD_GetWindowHeight( Wh )) ){
		if( !SetScreenSurface() ) return false;
		vm->el->staw->Init( OSD_GetWindowWidth( Wh ) );	// Xe[^Xo[
	}else
		// 蒼Ȃꍇ݂͌̃XN[T[tFXNA
		OSD_ClearWindow( Wh );
	
	return true;
}


////////////////////////////////////////////////////////////////
// ʍXV
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::DrawScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][DrawScreen]\n" );
	
	VSurface *BBuf = vm->vdg;		// obNobt@ւ̃|C^擾
	
	if( !Wh || !BBuf ) return;
	
	// XN[T[tFXblit
	PRINTD( GRP_LOG, " -> Blit" );
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	if( DISPMON ){	// j^[h?
		PRINTD( GRP_LOG, " -> Monitor" );
		
		// obNobt@
		OSD_BlitToWindow( Wh, BBuf, 0, 0 );
		
		// j^EBhE
		OSD_BlitToWindow( Wh, vm->el->monw, 0, P6WINH/2 );
		
		// WX^EBhE
		OSD_BlitToWindow( Wh, vm->el->regw, max( P6WINW/2, vm->el->monw->Width() ), 0 );
		
		// EBhE
		OSD_BlitToWindow( Wh, vm->el->memw, max( P6WINW/2, vm->el->monw->Width() ), vm->el->regw->Height() );
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	{
		if( DISPFULL ){	// tXN[\
			PRINTD( GRP_LOG, " -> FullScreen" );
			OSD_BlitToWindowEx( Wh, BBuf, ( OSD_GetWindowWidth( Wh ) - ScreenX() ) / 2, ( OSD_GetWindowHeight( Wh ) - ScreenY() ) / 2, ScreenY(), DISPNTSC, DISPSCAN, vm->el->cfg->GetScanLineBr() );
		}else{			// EBhE\
			PRINTD( GRP_LOG, " -> Window" );
			OSD_BlitToWindowEx( Wh, BBuf, 0, 0, ScreenY(), DISPNTSC, DISPSCAN, vm->el->cfg->GetScanLineBr() );
		}
		
		// Xe[^Xo[
		if( DISPSTAT ){
			PRINTD( GRP_LOG, " -> Statusbar" );
			
			// Xe[^Xo[XV
			// XN[T[tFX[Ɉʒu킹blit
			vm->el->staw->Update();
			OSD_BlitToWindow( Wh, vm->el->staw, 0, OSD_GetWindowHeight( Wh ) - vm->el->staw->Height() );
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	// tbv
	OSD_RenderWindow( Wh );
}


////////////////////////////////////////////////////////////////
// LXN[擾
//
// :	Ȃ
// Ԓl:	int		LXN[sNZ
////////////////////////////////////////////////////////////////
int DSP6::ScreenX( void ) const
{
	return DISPFULL ? P6WIFW : P6WINW;
}


////////////////////////////////////////////////////////////////
// LXN[擾
//
// :	Ȃ
// Ԓl:	int		LXN[sNZ
////////////////////////////////////////////////////////////////
int DSP6::ScreenY( void ) const
{
	return DISPFULL ? P6WIFH : DISPNTSC ? HBBUS : P6WINH;
}


////////////////////////////////////////////////////////////////
// Tuobt@擾
//
// :	Ȃ
// Ԓl:	VSurface *	Tuobt@ւ̃|C^
////////////////////////////////////////////////////////////////
VSurface *DSP6::GetSubBuffer( void )
{
	return NULL;
//	return SBuf;
}


////////////////////////////////////////////////////////////////
// EBhEnh擾
//
// :	Ȃ
// Ԓl:	HWINDOW *	EBhEnh
////////////////////////////////////////////////////////////////
HWINDOW DSP6::GetWindowHandle( void )
{
	return (HWINDOW)Wh;
}


////////////////////////////////////////////////////////////////
// Tuobt@XV
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
#define	RESO43		256		/* ԐFvZp\(1CRESO43) */
/*
bool DSP6::UpdateSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][UpdateSubBuf]\n" );
	
	VSurface *BBuf = vm->vdg;
	
	if( !BBuf ) return false;
	if( !RefreshSubBuf() ) return false;
	
	const bool dntsc = DISPNTSC;
	const bool dscan = DISPSCAN;
	const int brscan = vm->el->cfg->GetScanLineBr();
	const int xsc    = BBuf->XScale();
	const int yy     = SBuf->Height();
	const int xx     = BBuf->Width();
	
	for( int y=0; y<yy; y++ ){
		DWORD y0 = ( y * BBuf->Height() ) / yy;
		DWORD a1 = ( y * BBuf->Height() * RESO43 ) / yy - y0 * RESO43;
		DWORD a2 = RESO43 - a1;
		
		DWORD *sof1 = (DWORD *)BBuf->GetPixels() + BBuf->Pitch()/sizeof(DWORD) * y0;
		DWORD *sof2 = sof1 + ( y0 < (DWORD)BBuf->Height()-1 ? BBuf->Pitch()/sizeof(DWORD) : 0 );
		DWORD *doff = (DWORD *)SBuf->GetPixels() + SBuf->Pitch()/sizeof(DWORD) * y ;
		
		for( int x=0; x<xx; x++ ){
			DWORD r,g,b;
			DWORD d1 = *sof1++;
			DWORD d2 = *sof2++;
			
			if( dntsc ){
				r = ( ( ( (d1>>RSHIFT32)&0xff ) * a2 + ( (d2>>RSHIFT32)&0xff ) * a1 ) / RESO43 ) & 0xff;
				g = ( ( ( (d1>>GSHIFT32)&0xff ) * a2 + ( (d2>>GSHIFT32)&0xff ) * a1 ) / RESO43 ) & 0xff;
				b = ( ( ( (d1>>BSHIFT32)&0xff ) * a2 + ( (d2>>BSHIFT32)&0xff ) * a1 ) / RESO43 ) & 0xff;
			}else{
				r = (d1>>RSHIFT32)&0xff;
				g = (d1>>GSHIFT32)&0xff;
				b = (d1>>BSHIFT32)&0xff;
			}
			
			if( dscan && y&1 ){
				r = ( ( r * brscan ) / 100 ) & 0xff;
				g = ( ( g * brscan ) / 100 ) & 0xff;
				b = ( ( b * brscan ) / 100 ) & 0xff;
			}
			*doff++ = (r<<RSHIFT32) | (g<<GSHIFT32) | (b<<BSHIFT32);
			if( xsc == 1 ) *doff++ = (r<<RSHIFT32) | (g<<GSHIFT32) | (b<<BSHIFT32);
		}
	}
	
	PRINTD( GRP_LOG, " -> %sScanLine -> OK\n", DISPSCAN ? "" : "No " );
	
	return true;
}


////////////////////////////////////////////////////////////////
// Tuobt@tbV
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::RefreshSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][RefreshSubBuf]\n" );
	
	if( SBuf ){
		if( SBuf->Width() == ScreenX() && SBuf->Height() == ScreenY() ){
			// TCYςĂȂOK
			PRINTD( GRP_LOG, " X:%d Y:%d -> OK\n", SBuf->Width(), SBuf->Height() );
			return true;
		}else{
			// Tuobt@U폜
			delete SBuf;
			SBuf = NULL;
		}
	}
	
	// Tuobt@쐬
	PRINTD( GRP_LOG, " Create SubBuffer X:%d Y:%d\n", ScreenX(), ScreenY() );
	SBuf = new VSurface;
	if( !SBuf ) return false;
	
	if( !SBuf->InitSurface( ScreenX(), ScreenY() ) ){
		delete SBuf;
		SBuf = NULL;
		return false;
	}
	
	return true;
}
*/


////////////////////////////////////////////////////////////////
// XibvVbg
//
// :	path	XN[Vbgi[pX
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::SnapShot( const char *path )
{
	PRINTD( GRP_LOG, "[GRP][SnapShot]\n" );
	
	char img_file[PATH_MAX];
	char img_name[PATH_MAX] = "P6V";
	int Index = 0;
	
	// XibvVbgi[tH_Ȃ΃G[
	if( !OSD_FileExist( path ) ) return;
	
	// XibvVbgt@C߂
	do{
		sprintf( img_file, "%s%s%03d.%s", path, img_name, ++Index, IMG_EXT );
	}while( OSD_FileExist( img_file ) || (Index > 999) );
	
	// AԂLȂ摜t@Cۑ
	if( !(Index > 999) ){
		VRect scr;
		
		scr.x = scr.y = 0;
		scr.w = DISPFULL ? P6WIFW : P6WINW;
		scr.h = DISPFULL ? P6WIFH : DISPNTSC ? HBBUS : P6WINH;
		
		BYTE *pixels = new BYTE[scr.w * scr.h * sizeof(DWORD)];
		if( !pixels ) return;
		
		if( !OSD_GetWindowImage( Wh, (void **)(&pixels), &scr ) ) return;
		SaveImgData( img_file, pixels, 32, scr.w, scr.h, NULL );
		
		if( pixels ) delete [] pixels;
	}
}
